// http://stackoverflow.com/questions/1068834/object-comparison-in-javascript

function countProps(obj) {
  var count = 0;
  for (var k in obj) {
    if (obj.hasOwnProperty(k)) {
        count++;
    }
  }
  return count;
}

function objectEquals(v1, v2, seen) {
  if (seen && (v1 in seen || v2 in seen)) {
    return true;
  }

  if (typeof(v1) !== typeof(v2)) {
    return false;
  }

  if (typeof(v1) === "function") {
    return v1.toString() === v2.toString();
  }

  if (v1 instanceof Object && v2 instanceof Object) {
    if (countProps(v1) !== countProps(v2)) {
      return false;
    }

    if (!seen) {
      seen = {};
    }

    seen[v1] = true;
    seen[v2] = true;

    for (var k in v1) {
      if (v1.hasOwnProperty(k) && v2.hasOwnProperty(k) && !objectEquals(v1[k], v2[k], seen)) {
        return false;
      }
    }

    delete seen[v1];
    delete seen[v2];

    return true;
  } else {
    return v1 === v2;
  }
}

