var Analytics = {

};


Analytics.Console = function() {
  this.install = function() {
    console.log("installed console analytics");
  };

  this.trackPageView = function(pageName) {
    console.log("TrackPageView: " + pageName);
  };

    this.trackEvent = function(eventCategory, eventAction, eventLabel, eventValue) {
    console.log("TrackEvent. EventCategory: " + eventCategory + ", EventAction: " + eventAction + ", EventLabel: " + eventLabel + ", EventValue: " + eventValue);
  };
};

Analytics.iPhone = function() {
  this.install = function() {
    console.log("Installed iOS analytics");
  };

  this.trackPageView = function(pageName) {
    PhoneGap.exec("PhonegapAnalytics.trackPageView", pageName);
  };

    this.trackEvent = function(eventCategory, eventAction, eventLabel, eventValue) {
    PhoneGap.exec("PhonegapAnalytics.trackEventName", eventCategory, eventAction, eventLabel, eventValue);
  };
};


Analytics.Android = function() {
  this.install = function() {
    PhoneGap.addPlugin("Analytics", this);
    PluginManager.addService("Analytics", "com.playup.soccer.analytics.PhonegapAnalytics");
  };

  this.trackPageView = function(pageName) {
    PhoneGap.exec(null, null, "Analytics", "trackPageView", [pageName]);
  };

    this.trackEvent = function(eventCategory, eventAction, eventLabel, eventValue) {
    PhoneGap.exec(null, null, "Analytics", "trackEvent", [eventCategory, eventAction, eventLabel, eventValue]);
  };

};


var ANALYTICS = {
  trackEvent: function() {},
  trackPageView: function() {},

  trackEntrySubmission: function(type) {
    switch(type) {
      case 'cash':
        this.trackEvent('Play', 'Tap', 'AccountPlay', 0);
        break;

      case 'points':
        this.trackEvent('Play', 'Tap', 'FreePlay', 0);
        break;

      case 'sms':
        this.trackEvent('Play', 'Tap', 'SMSPlay', 0);
        break;
    }    
  },

  trackEntryCompletion: function(type) {
    switch(type) {
      case 'cash':
        ANALYTICS.trackEvent('Play', 'Notification', 'AccountPlaySuccesfullEntry', 0);
        break;
      case 'points':
        ANALYTICS.trackEvent('Play', 'Notification', 'FreePlaySuccesfullEntry', 0);
        break;
      case 'sms':
        ANALYTICS.trackEvent('Play', 'Notification', 'SMSPlaySuccesfullEntry', 0);
        break;
    }
  }
};

Analytics.Factory = {
  create: function(platform) {
    switch (platform) {
      case "iPhone":
        return new Analytics.iPhone();
      case "iPad":
        return new Analytics.iPhone();
      case "iPod":
        return new Analytics.iPhone();
      case "Android":
        return new Analytics.Android();
      default:
        return new Analytics.Console();
    }
  },

  install: function(platform) {
    var analytics = this.create(platform);
    analytics.install();

    // doing it this way lets us keep custom stuff on the ANALYTICS object
    ANALYTICS.trackPageView = analytics.trackPageView;
    ANALYTICS.trackEvent = analytics.trackEvent;
  }
};


if (typeof PhoneGap == "undefined") {
  Analytics.Factory.install("desktop browser");
} else {
  document.addEventListener("deviceready", function() {
    PhoneGap.addConstructor(function() {
      Analytics.Factory.install(device.platform);
    });
  }, false);
}
