var SMSSender = {

};

SMSSender.Android = function() {
  this.install = function() {
    PhoneGap.addPlugin("SMSSender", new SMSSender.Android());
    PluginManager.addService("SMSSender", "com.playup.soccer.sms.SMSSender");
  };

  this.sendSMS = function(smsNumber, message, success, fail) {
    return PhoneGap.exec(success, fail, "SMSSender", "sendSMS", [smsNumber, message]);
  };
};

SMSSender.Console = function() {
  this.install = function() {
    console.log("installed console sms sender");
  };

  this.sendSMS = function(smsNumber, message, success, fail) {
    console.log("sendSms: " + smsNumber + ", message: " + message);
    success();
    return true;
  };
};

SMSSender.iPhone = function() {
  var self = this;
  this.sendSMS = function(smsNumber, message, success, fail) {
    self.success = success;
    self.fail = fail;
    PhoneGap.exec("SendSMS.sendSMS", smsNumber, message);
  };
};

var SMS;

if (typeof PhoneGap == "undefined") {
  SMS = new SMSSender.Console();
  SMS.install();
} else {
  document.addEventListener("deviceready", function() {
    PhoneGap.addConstructor(function() {
      SMS = new SMSSender[device.platform]();
      SMS.install();
    });
  }, false);
}