function FooterUI(element) {
  var self = this;
  self.element = element;
  element.find('.matches').bindAndStopPropagation(UI.tapEvent, function() {
    ANALYTICS.trackEvent('FooterBar', 'Tap', 'Matches', 0);
    UI.gotoFixtures();
  });
  element.find('.tab').bindAndStopPropagation(UI.tapEvent, function(e) {
    var footer = self.element;
    if (footer.hasClass("expanded")) {
      ANALYTICS.trackEvent('FooterBar', 'Tap', 'Collapse Footer', 0);
      footer.removeClass("expanded").addClass("collapsed");
    } else {
      ANALYTICS.trackEvent('FooterBar', 'Tap', 'Expand Footer', 0);
      footer.removeClass("collapsed").addClass("expanded");
    }
  });

  element.find('.more > a').bindAndStopPropagation(UI.tapEvent, function() {
    ANALYTICS.trackEvent('FooterBar', 'Tap', 'More', 0);
    UI.gotoMore();
  });

  element.find(".playhistory > a").bindAndStopPropagation(UI.tapEvent, function() {
    ANALYTICS.trackEvent('FooterBar', 'Tap', 'PlayHistory', 0);
    UI.ensureLoggedIn(function() {
      UI.gotoPlayHistory();
    });
  });

  element.find(".leaderboard > a").bindAndStopPropagation(UI.tapEvent, function() {
    ANALYTICS.trackEvent('FooterBar', 'Tap', 'Leaderboard', 0);
    UI.gotoLeaderboard();
  });

  element.find(".mypage > a").bindAndStopPropagation(UI.tapEvent, function() {
    UI.ensureLoggedIn(function() {
      ANALYTICS.trackEvent('FooterBar', 'Tap', 'My Page', 0);
      UI.gotoMyPage();
    });
  });

}


$(function() {
  UI.footer = new FooterUI($('footer').first());
});
