function LeaderboardUI(element) {
  var self = this;
  this.element = element;
  this.loginField = element.find('.details > h2 > em');
  this.myRanking = element.find('.my-ranking');
  this.myRankingField = element.find('.current-rank');

  self.content = element.find('.leaderboard-results tbody');
}

LeaderboardUI.prototype.update = function(leaderboard) {
  var self = this;
  self.content.html("");
  self._appendPups(leaderboard);
  UI.updateScroller('leaderboard');
};

LeaderboardUI.prototype._appendPups = function(pups) {
  var self = this;
  for(var i in pups) {
    var pup = pups[i];
    self.content.append("<tr class='pup'><td>" + pup.position + "</td><td>" + pup.name + "</td><td>" + pup.points + "</td></tr>");
  }
};

LeaderboardUI.prototype.setupUser = function(user) {
  if (user) {
    this.loginField.text(user.login);
    this.myRanking.show();
    var rank = user.rank ? Util.commas(user.rank.score) : "-";
    this.myRankingField.text(rank);
  } else {
    this.loginField.text("");
    this.myRanking.hide();
  }
};


$(function() {
  UI.leaderboard = new LeaderboardUI($('#leaderboard-screen'));
});

