Match = function(options) {
  this.homeTeam = options.homeTeam;
  this.awayTeam = options.awayTeam;
  this.teams = [this.homeTeam, this.awayTeam];

  this.players = {};

  for (var team_index in this.teams) {
    var team = this.teams[team_index];

    for (var i in team.players) {
      var player = team.players[i];
      this.players[player.id] = player;
    }
  }
};

Match.prototype.afterBecome = function() {
  this.teams = eachBecome([this.homeTeam, this.awayTeam], Team);
  this.players = {};

  for (var team_index in this.teams) {
    var team = this.teams[team_index];

    for (var i in team.players) {
      var player = team.players[i];
      this.players[player.id] = player;
    }
  }
};

Match.prototype.usePlayersFrom = function(otherMatch) {
  this.homeTeam.usePlayersFrom(otherMatch.homeTeam);
  this.awayTeam.usePlayersFrom(otherMatch.awayTeam);
  this.players = otherMatch.players;
};

Match.prototype.enticementPlayer = function() {
  var candidates = [];

  for (var id in this.players) {
    var player = this.players[id];

    if (player.fansAgreePercentage > 0) {
      candidates.push(player);
    }
  }

  if (candidates.length > 0) {
    return candidates[Math.floor(Math.random() * (candidates.length - 1))];
  }
  else {
    return this.homeTeam.players[0];    // TODO something something better
  }
};

Match.prototype.soccer1upStatus = function() {
  return this.games.soccer1up ? "available" : "unavailable"; 
};

// convert match time from offset hash to a string
Match.prototype.setNow = function(now) {
  if (this.matchTime instanceof Object) {
    this.matchTime = Util.formatMatchTime(Util.dateToUnixTime(now) - this.matchTime.base + this.matchTime.start * 60, this.matchTime.end);
  }
};
