function MypageUI(element) {

  var self = this;
  this.element = element;

  this.logoutButton = element.find(".logout");
  this.logoutButton.bindAndStopPropagation(UI.tapEvent, function() {
    ANALYTICS.trackEvent('MyPage', 'Tap', 'Logout', 0);
    PUGE.logout(); 
    UI.screen('fixtures'); 
  });

  this.emailSettingsButton = element.find(".email-settings");
  this.cashField = element.find('.details .cash span');
  this.tokenField = element.find('.details .tokens');
  this.ageVerificationMenuItem = element.find(".age-verification");
  this.bankWithdrawalMenuItem = element.find(".bank-withdrawal");
  this.loginField = element.find('.details > h2 > em');

  this.playHistoryButton = element.find(".playhistory");
  this.playHistoryButton.bindAndStopPropagation(UI.tapEvent, function() {
    ANALYTICS.trackEvent('MyPage', 'Tap', 'PlayHistory', 0);
    UI.gotoPlayHistory();
  });

  this.leaderboardButton = element.find(".leaderboard");
  this.leaderboardButton.bindAndStopPropagation(UI.tapEvent, function() {
    ANALYTICS.trackEvent('MyPage', 'Tap', 'Leaderboard', 0);
    UI.gotoLeaderboard();
  });

  this.logoutButton.bindAndStopPropagation(UI.tapEvent, function() {PUGE.logout(); UI.screen('fixtures'); });
  this.emailSettingsButton.bindAndStopPropagation(UI.tapEvent, function() {
    ANALYTICS.trackEvent('MyPage', 'Tap', 'EmailSettings', 0);
    self.emailSettingsButton.toggleClass('selected');
    self.element.find(".email-settings-menu").toggleClass('collapsed');
  });

  this.scroller = null;

}

MypageUI.prototype.setupUser = function(user) {
  if (user) {
    this.cashField.text(Util.money(user.cash));
    this.tokenField.text(Util.commas(user.tokens));
    this.loginField.text(user.login);
    this._doAgeVerificationMenuItem(user);
    this._doBankWithdrawalMenuItem(user);
    UI.updateScroller('mypage');
  }
};

MypageUI.prototype._doAgeVerificationMenuItem = function(user) {
  if (user.ageVerified) {
    this.ageVerificationMenuItem.hide();
  } else {
    this.ageVerificationMenuItem.show();
  }
};

MypageUI.prototype._doBankWithdrawalMenuItem = function(user) {
  if (user.allowBankWithdrawals && user.cash > 0) {
    this.bankWithdrawalMenuItem.show();
  } else {
    this.bankWithdrawalMenuItem.hide();
  }
};

$(function() {
  UI.mypage = new MypageUI($('#mypage-screen'));
});

