function RegisterUI(element) {

  this.registerButton = element.find('#register-now');
  this.cancelButton = element.find('#register-cancel');
  this.login = element.find('#register-login');
  this.email = element.find('#register-email');
  this.password = element.find('#register-password');
  this.passwordConfirmation = element.find('#register-password-confirmation');
  this.terms_and_conditions = element.find('#register-terms_and_conditions');
  this.fbLogin = element.find('.fb-login');

  this.errors = element.find('#registration-errors');
    
  var self = this;

  this.registerButton.bindAndStopPropagation(UI.tapEvent, function() { self.performRegister();});
  this.cancelButton.bindAndStopPropagation(UI.tapEvent, function() { self.performCancel(); });
  this.fbLogin.bindAndStopPropagation('click', function() { self.facebookLogin(); });
}

RegisterUI.prototype.performRegister = function() {
    ANALYTICS.trackEvent('Register', 'Tap', 'RegisterNow', 0); // RegisterNow Button on Register screen
    var params = {
        playup_player: {
          login: this.login.val(),
          email: this.email.val(),
          password: this.password.val(),
          password_confirmation: this.passwordConfirmation.val(),
          terms_and_conditions: $('#register-terms_and_conditions:checked').length
        },
        login: this.login.val(),
        password: this.password.val()
    };

    PUGE.register(params, function(success, errors) {
        if(success) {
            ANALYTICS.trackEvent('Register', 'Notification', 'CheckYourEmail', 0); // Check your email popup
            UI.screen(UI.login.nextScreen);
            UI.popup('registration-success');
        } else {
            console.log(errors);
            var errorHtml = "";
            for(var i=0; i < errors.length; i++) {
                errorHtml = errorHtml + "<li>" + errors[i] + "</li>";
            }
            UI.register.errors.html(errorHtml);
        }
    });
};

RegisterUI.prototype.performCancel = function() {
  ANALYTICS.trackEvent('Register', 'Tap', 'Cancel', 0); // Cancel Button on Register screen
  UI.screen('login');
};

RegisterUI.prototype.facebookLogin = function() {
  ANALYTICS.trackEvent('Register', 'Tap', 'Facebook', 0);
  UI.facebookLogin();
};

$(function() {
  UI.register = new RegisterUI($('#register-screen'));
});