function ToolbarUI(element) {
  this.element = element;

  element.find('.back').bindAndStopPropagation(UI.tapEvent, function() {
    UI.goBack();
  });

  if ('BackButton' in window) {
    BackButton.override();
    document.addEventListener('backKeyDown', function(e) {
      if (!UI.goBack()) {
        BackButton.exitApp();
      }
    }, false);
  }

  element.find('.login').bindAndStopPropagation(UI.tapEvent, function() {
    ANALYTICS.trackEvent('Header', 'Tap', 'Login / Register', 0);
    UI.gotoLogin();
  });

  this.cashField = element.find('.cash span');
  this.rankField = element.find('.rank .score');
  this.rankWeek = element.find('.rank .title');
  this.loginField = element.find('.welcome span');
  this.pointsField = element.find('.points span');
}

ToolbarUI.prototype.setupUser = function(user) {
  if (user) {
    this.loginField.text(user.login);
    this.cashField.text(Util.money(user.cash));

    this._setupRank(user);

    $('body').addClass('logged-in');
  }
  else {
    $('body').removeClass('logged-in');
  }
};

ToolbarUI.prototype._setupRank = function(user) {
  var rank = "-";
  var rankHeading = "Weekly Rank";
  var points = "-";

  if (user.rank) {
    rank = Util.commas(user.rank.score);
    points = Util.commas(user.rank.points);
  }
  this.pointsField.text(points);
  this.rankField.text(rank);
  this.rankWeek.text(rankHeading);
};

$(function() {
  UI.toolbar = new ToolbarUI($('nav.toolbar').first());
});
